using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Runtime.ExceptionServices;
using System.Security.Permissions;
using UnityEngine;
using UnityEngine.Events;

namespace NY
{
    public class NY
    {
        public static void Main()
        {
                    CategoryBuilder.Create("New Year's pack", "2022 Cooming soon...",ModAPI.LoadSprite("logo.png"));

                        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crossbow"),
                    NameOverride = "<color=white>[<color=red>2022<color=white>] Gift Thrower",
                    NameToOrderByOverride = "GiftTH",
                    DescriptionOverride = "NYP",
                    CategoryOverride = ModAPI.FindCategory("New Year's pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/thrower.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/giftshot.png");
           Instance.FixColliders();
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("<color=white>[<color=red>2022<color=white>] Gift");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileLaunchStrength = 5f;
           Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Wood");

                    }
                }
            );
                       ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "<color=white>[<color=red>2022<color=white>] Santa Claus",
                    NameToOrderByOverride = "Santa",
                    DescriptionOverride = "NYP",
                    CategoryOverride = ModAPI.FindCategory("New Year's pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/santa.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Sprites/santa.png");
                        var flesh = ModAPI.LoadTexture("flesh.png");
                        var bone = ModAPI.LoadTexture("bone.png");
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBloodColour(89, 129, 191);
                    
                           foreach (var body in person.Limbs)
                           {
                               var backpack = new GameObject("Backpack");
                               backpack.transform.SetParent(Instance.transform.Find("Head"));
                               backpack.transform.localPosition = new Vector3(0.0042f, 0.0024f);
                               backpack.transform.localScale = new Vector3(1f, 1f);
                               var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                               backpackSprite.sprite = ModAPI.LoadSprite("Sprites/santa_hair.png", 1.4f);
                               backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                               }
                            foreach (var body in person.Limbs)
                               {
                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
                                backpack.transform.localPosition = new Vector3(0, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("Sprites/Plas.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        }       
                    }
                }
            ); 
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Axe"),
                    NameOverride = "<color=white>[<color=red>2022<color=white>] Red Axe",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "NYP",
                    CategoryOverride = ModAPI.FindCategory("New Year's pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/AxeThumb.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        var axeHandle = Instance.transform.GetChild(0);
                        axeHandle.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Axe1.png");
                        var axeHead = axeHandle.GetChild(0);
                        axeHead.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Axe2.png");
                        var properties = ModAPI.FindPhysicalProperties("Metal");
                        properties.Sharp = true;
                        properties.SharpAxes = new SharpAxis[]
                        {
                            new SharpAxis(Vector2.right, 0f, 0.5f, true, false)
                        };
                        axeHead.gameObject.GetComponent<PhysicalBehaviour>().Properties = properties;
                    }
                }
            );
                                    ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crossbow"),
                    NameOverride = "<color=white>[<color=red>2022<color=white>] Icicle Thrower",
                    NameToOrderByOverride = "Icicle Thrower",
                    DescriptionOverride = "NYP",
                    CategoryOverride = ModAPI.FindCategory("New Year's pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Icicle Thrower.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Icicle Thrower.png");
           Instance.FixColliders();
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("<color=white>[<color=red>2022<color=white>] Icicle");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileLaunchStrength = 5f;
           Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Wood");

                    }
                }
            );
               
                        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "<color=white>[<color=red>2022<color=white>] Gift",
                    NameToOrderByOverride = "Gift",
                    DescriptionOverride = "NYP",
                    CategoryOverride = ModAPI.FindCategory("New Year's pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/gifts.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/Gift.png");
                                             Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("sprites/Gift.png"),
                                    ModAPI.LoadSprite("sprites/Gift2.png"),
                                    ModAPI.LoadSprite("sprites/Gift3.png"),
                                    ModAPI.LoadSprite("sprites/Gift4.png"),
                                    ModAPI.LoadSprite("sprites/Gift5.png")
                                };

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                    }
                }
            );

                    ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Crossbow"),
                NameOverride = "<color=white>[<color=red>2022<color=white>] Machine for launching fireworks",
                DescriptionOverride = "NYP",
                CategoryOverride = ModAPI.FindCategory("New Year's pack"),
                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/firework.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/Firework.png");
                                 Instance.FixColliders();
    var Light = new GameObject("Glow");
    Light.transform.SetParent(Instance.transform);
    Light.transform.rotation = Instance.transform.rotation;
    Light.transform.localPosition = new Vector3(0f, .0f);
    Light.transform.localScale = new Vector3(1f, 1f);

    var LightSprite = Light.AddComponent<SpriteRenderer>();
    LightSprite.sprite = ModAPI.LoadSprite("sprites/firework_glow.png", 1f); //GlowSprite should be completely white
    LightSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
    LightSprite.color = new Color32(255, 36, 0, 15); //change the colour here
    LightSprite.sortingLayerName = "Object";

                    var launcher = Instance.GetComponent<ProjectileLauncherBehaviour>();
                    launcher.projectileAsset = ModAPI.FindSpawnable("Fireworks");
                    launcher.IsAutomatic = true;
                    launcher.AutomaticInterval = 0.05f;
                    launcher.projectileLaunchStrength = 0f;
                    launcher.RemoveLaunchedObjectsWithMe = true;
                    launcher.barrelPosition = new Vector2(0.75f, 0.1f);

                    launcher.OnLaunch += (sender, proj) =>
                    {

                        proj.transform.localScale = Instance.transform.localScale;
                        proj.AddComponent<FirestormProjectileBehaviour>();
                        var firework = proj.GetComponent<FireworksBehaviour>();
                        firework.Thrust *= 4f;
                        firework.Life *= 2f;
                        firework.Activated = true;
                        firework.Audio.Play();
                    };
                }
            }
        ); 
                              ModAPI.Register(
               new Modification()
               {
                   OriginalItem = ModAPI.FindSpawnable("Crossbow Bolt"),
                   NameOverride = "<color=white>[<color=red>2022<color=white>] Icicle",
                   NameToOrderByOverride = "Icicle",
                   DescriptionOverride = "NYP",
                   CategoryOverride = ModAPI.FindCategory("New Year's pack"),
                   ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Icicle.png"),
                   AfterSpawn = (Instance) =>
                   {
                       Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/Icicle.png");
                       
                       Instance.FixColliders();
                     }
                 }
             );
                                           ModAPI.Register(
               new Modification()
               {
                   OriginalItem = ModAPI.FindSpawnable("Rod"),
                   NameOverride = "<color=white>[<color=red>2022<color=white>] Ice Cube",
                   NameToOrderByOverride = "Icicle",
                   DescriptionOverride = "NYP",
                   CategoryOverride = ModAPI.FindCategory("New Year's pack"),
                   ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Ice.png"),
                   AfterSpawn = (Instance) =>
                   {
                       Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/Ice.png");

                       Instance.FixColliders();
                     }
                 }
             );
                                                        ModAPI.Register(
               new Modification()
               {
                   OriginalItem = ModAPI.FindSpawnable("Stick"),
                   NameOverride = "<color=white>[<color=red>2022<color=white>] Christmas tree",
                   NameToOrderByOverride = "Christmas tree",
                   DescriptionOverride = "NYP",
                   CategoryOverride = ModAPI.FindCategory("New Year's pack"),
                   ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/tree.png"),
                   AfterSpawn = (Instance) =>
                   {
                       Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/tree.png");

                       Instance.FixColliders();
                     }
                 }
             );
                      ModAPI.Register(
               new Modification()
               {
                   OriginalItem = ModAPI.FindSpawnable("Stick"),
                   NameOverride = "<color=white>[<color=red>2022<color=white>] Santa Claus hat",
                   NameToOrderByOverride = "hat",
                   DescriptionOverride = "NYP",
                   CategoryOverride = ModAPI.FindCategory("New Year's pack"),
                   ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/hat.png"),
                   AfterSpawn = (Instance) =>
                   {
                       Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/hat.png");

                       Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");

                       ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                       armor.stabResistance = 0f;
                       armor.armorPiece = "Head";
                       armor.armorTier = 0;

                       Instance.FixColliders();
                     }
                 }
             );
            
        }
    }



    public class BurstFireAdapter : MonoBehaviour
    {
        public float Interval = 0.1f;
        public int BurstCount = 5;

        private bool busy = false;

        private CanShoot firearm;

        private void Awake()
        {
            firearm = GetComponent<CanShoot>();
        }

        private void Use()
        {
            StartCoroutine(Burst());
        }

        private System.Collections.IEnumerator Burst()
        {
            if (busy) yield break;
            busy = true;
            for (int i = 0; i < BurstCount - 1; i++)
            {
                yield return new WaitForSeconds(Interval);
                firearm.Shoot();
            }
            busy = false;
        }
    }
}

